searchNodes=[{"doc":"Dragonite - Fast, reliable and configurable EDI parser (encode &amp; decode), seeker &amp; rule runner.","ref":"Dragonite.html","title":"Dragonite","type":"module"},{"doc":"Dragonite.Config is used to handle the config for rules in a runtime environment allowing reload or get the rules.To configure the rules:config :dragonite, rules_file: &quot;./rules.yml&quot;The rules have a defined structure and must be placed into an available directory, please check priv directory to know how config for YML is used, the next is a single example of how YML structure works:- isa: 04: &quot;$edi_customer.edi_provider_id&quot; ### ISA at position 04 MUST match with edi_provider_id value at database 05: &quot;08&quot; ### ISA at position 05 MUST match 08 string. 06: - {el: &quot;gs&quot;, value: &quot;02&quot;} ### ISA at position 05 MUST have same value in GS at position 02 15: - &quot;P&quot; ### ISA at position 15 MUST match P or T string, other value is not valid. - &quot;T&quot; 16: - {el: &quot;st&quot;, value: &quot;$length&quot;} ### ISA at position 16 should contains the length of ST elements, if ST elements are 6 this position MUST have 6.The above structure is translated to a single list and can be used to perform validations over an EDI message.The newly added wildcard with database works only with edi_customer reference, because this info collects from the parsing event and can be translated to rules.","ref":"Dragonite.Config.html","title":"Dragonite.Config","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Dragonite.Config.html#child_spec/1","title":"Dragonite.Config.child_spec/1","type":"function"},{"doc":"Reloads the rules file and store the new rules in runtime.Exampleiex(1)&gt; Dragonite.Config.reload()","ref":"Dragonite.Config.html#reload/0","title":"Dragonite.Config.reload/0","type":"function"},{"doc":"Returns the rules already loaded.Exampleiex(1)&gt; Dragonite.Config.rules()","ref":"Dragonite.Config.html#rules/0","title":"Dragonite.Config.rules/0","type":"function"},{"doc":"Returns the rules already loaded for a specific type.Exampleiex(1)&gt; Dragonite.Config.rules(204)","ref":"Dragonite.Config.html#rules/1","title":"Dragonite.Config.rules/1","type":"function"},{"doc":"Returns the file config used for rules in the environment.","ref":"Dragonite.Config.html#rules_file/0","title":"Dragonite.Config.rules_file/0","type":"macro"},{"doc":"Dragonite.Parser is the module to handle decode and encode for an EDI message.DecodingTo decode a message, use the decode/1 function, providing a string as argument. The decode function tries to decode the message into an %DragoniteEDI.Message{} struct and raises an error if the message provided is not a valid message. To decode the parser follow the next rules:Must start with ISA struct.Must end with IEA struct.Function groups start with GS and end with GE.Segments start with ST and end with SE.Separator for elements is ~Separator for elements into fields is *This is a single example of an EDI message:iex(1)&gt; msg = &quot;ISA*00* *00* *32*0000*32*0000 *121206*1142*U*00601*000000003*1*T*&gt;~&quot; &lt;&gt; &quot;GS*SM*300237446*351538247*20121206*1142*3*X*006010~ST*204*000000001~B2**BWEM**317749**CC*L~&quot; &lt;&gt; &quot;B2A*00*FR~L11*SMC LTL Fuel*XX7*Fuel Schedule: SMC LTL Fuel~L11*104*ZZ*Total Distance:104~G6&quot; &lt;&gt; &quot;2*64*20121206*1*1244*LT~AT5*400**Transport~RTT*FC*550~C3*USD~N1*BT*Pokemon GO*93*2649&quot; &lt;&gt; &quot;~N3*19661 Brownstown Center Dr*Suite 600~N4*Brownstown*MI*48183-1679*USA~G61*LG*Contact Phone&quot; &lt;&gt; &quot;*TE*000-000-000 ext 3~G61*LG*Contact Mobile*CP*000-000-0000~G61*LG*Contact Email*EM*&quot; &lt;&gt; &quot;dratini@pokemon.com~N7**Unknown*********53****0636*****110*98~S5*0*LD~L11*602465*SI~&quot; &lt;&gt; &quot;G62*69*20120810*U*1600*LT~N1*SH*POKEMON GO*93*5715~N3*603 7th St~N4*Pokemon*MI*49601-1344*&quot; &lt;&gt; &quot;USA~G61*LG*Contact Phone*TE*000-000-0000 ext 1357~G61*LG*Contact Email*EM*dratini@pokemon.com&quot; &lt;&gt; &quot;~N1*CN*ABC Undercar Products Group*93*9889~N3*4247 Paleta Town SE~N4*Wyoming*MI*49508-3400*USA~N1*&quot; &lt;&gt; &quot;SF*AVON AUTOMOTIVE*93*5715~N3*603 7th St~N4*Pokemon*MI*49601-1344*USA~G61*LG*Contact Phone*TE*&quot; &lt;&gt; &quot;000-000-0000 ext 1357~G61*LG*Contact Email*EM*dratini@pokemon.com~LAD*PLT****L**S1*264&quot; &lt;&gt; &quot;*****Freight All Kinds~L5*1**60*N~S5*1*UL~L11*602465*SI~G62*69*20120813*U*1600*LT~N1*SH*POKEMON&quot; &lt;&gt; &quot; GO*93*5715~N3*603 7th St~N4*Pokemon*MI*49601-1344*USA~G61*LG*Contact Phone*TE*000-000&quot; &lt;&gt; &quot;-0000 ext 1357~G61*LG*Contact Email*EM*dratini@pokemon.com~N1*CN*ABC &quot; &lt;&gt; &quot;Products Group*93*9889~N3*4247 Paleta Town SE~N4*Wyoming*MI*49508-3400*USA~N1*ST*ABC &quot; &lt;&gt; &quot; Products Group*93*9889~N3*4247 Paleta Town SE~N4*Wyoming*MI*49508-3400*USA~LAD*PLT&quot; &lt;&gt; &quot;****L**S1*264*****Freight All Kinds~L5*1**60*N~SE*51*000000001~GE*1*3~IEA*1*000000003&quot;Now to decode the above message just call to decode/1:iex(2)&gt; Dragonite.Parser.decode msgThe response (if valid) will be an %DragoniteEDI.Message{} struct containing all elements considered from parsing rules. New rules can de added if nedeed.Decoding multiple STsSometimes the incoming messages will contain multiple ST, this means that multiple messages are sent once a time.To support this, the decode/1 returns a list of messages instead a single response (even if only 1).EncodingTo encode a message use the encode/1 function, providing a DragoniteEDI.Message{} as argument. The encode function tries to encode the struct as a string message and raises an errir if the message provided is not a valid message. To encode a message:iex(1)&gt; Dragonite.Parser.encode %DragoniteEDI.Message{}The response is a single string as an original EDI message.VerificationBy default decode/1 verifies the struct and return {:ok, %DragoniteEDI.Message{}} or {:error, error} where error will describe the missing or incomplete struct. Missing or incomplete structs are marked when sub-structs are nil or empty lists.Validation can be skipped using verify: false when calling decode/2 using opts (2nd argument) as keywords.By default encode/1 verifies the struct of edi message, this is mandatory.RulesA single message can be passed (after parsed) for a set of rules to check if passed the criteria or not.The rules criteria are defined in a single YML file (see Config for more info).To check if a message pass the criteria:iex(1)&gt; Dragonite.Parser.to_rules %DragoniteEDI.Message{}, 204If passed the struct is returned, otherwise an error is returned.SeekSeek allows search in values of ST segment, match criteria and return values based on custom functions provided as a part of seek process. Seek process needs the values (that can be extracted using struct_at/3), the matching criteria, the values to return and a fn with two args, the first one is the resulting of matching criteria and the second one the return data.","ref":"Dragonite.Parser.html","title":"Dragonite.Parser","type":"module"},{"doc":"Tries to decode a single EDI message from a string into %DragoniteEDI.Message{}. Raises an argument error if message provided is not a valid message with the struct of EDI protocol.Exampleiex(1)&gt; Dragonite.Parser.decode &quot;ISA...&quot;","ref":"Dragonite.Parser.html#decode/2","title":"Dragonite.Parser.decode/2","type":"function"},{"doc":"Same as decode/1 but raises an error instead of return the error message.Exampleiex(1)&gt; Dragonite.Parse.decode! &quot;ISA...&quot;","ref":"Dragonite.Parser.html#decode!/2","title":"Dragonite.Parser.decode!/2","type":"function"},{"doc":"Tries to encode a single EDI message from struct into string. Raises an argument error if message provided is not a valid message with the struct of EDI protocol.Exampleiex(1)&gt; Dragonite.Parser.encode %DragoniteEDI.Message{}","ref":"Dragonite.Parser.html#encode/1","title":"Dragonite.Parser.encode/1","type":"function"},{"doc":"Same as encode/1 but raises an error instead of return the error message.Exampleiex(1)&gt; Dragonite.Parser.encode! %DragoniteEDI.Message{}","ref":"Dragonite.Parser.html#encode!/1","title":"Dragonite.Parser.encode!/1","type":"function"},{"doc":"Verifies if a DragoniteEDI.Message{} is valid, checking if all sub-structs are non empty and then mark message as valid. Return error at sub-struct incompleted.A custom check can be passed to skip the validation in order to use in some pipelines.Exampleiex(1)&gt; Dragonite.Parser.is_valid(%DragoniteEDI.Message{})","ref":"Dragonite.Parser.html#is_valid/2","title":"Dragonite.Parser.is_valid/2","type":"function"},{"doc":"Seek criteria and apply fun to elements foundExampleiex(1)&gt; Dragonite.Parser.seek([[&quot;L11&quot;, &quot;&quot;, &quot;&quot;]], [], [%{key: &quot;L11&quot;, pos: 1}], fn _, _ -&gt; :ok end)","ref":"Dragonite.Parser.html#seek/4","title":"Dragonite.Parser.seek/4","type":"function"},{"doc":"Get value at position, length or full values of some segment in Edi message structExampleiex(1)&gt; Dragonite.Parser.struct_at(%DragoniteEDI.Message{}, &quot;isa&quot;, 1)","ref":"Dragonite.Parser.html#struct_at/3","title":"Dragonite.Parser.struct_at/3","type":"function"},{"doc":"Check if a %DragoniteEDI.Message{} is valid against rules defined in environment, so don't need to pass rules, since they are loaded from pre-loaded config.If rules are empty the message is marked as valid, since there are no rules to check.The function returns either the message or an error containing the validation that breaks the rules.To work with wildcards just pass the wildcard as an enumerable of one struct:Dragonite.Parser.to_rules(%DragoniteEDI.Message{}, 204, [%MyStruct{qualifier: &quot;Q1&quot;}])After that definitions in YML against $custom.? will run extracting the value from custom struct provided.Exampleiex(1)&gt; Dragonite.Parser.to_rules(%DragoniteEDI.Message{}, 204)","ref":"Dragonite.Parser.html#to_rules/3","title":"Dragonite.Parser.to_rules/3","type":"function"},{"doc":"Struct defined for GE node at EDI message. GE node indicates the end of a functional group.fields - an enum of string fields.","ref":"DragoniteEDI.GE.html","title":"DragoniteEDI.GE","type":"module"},{"doc":"Struct defined for GS node at EDI message. GS node indicates the start of a functional group containing multiple segments.fields - an enum of string fields.st - an enumerable of DragoniteEDI.ST nodes. See DragoniteEDI.ST for more info.se - a node of DragoniteEDI.SE. See DragoniteEDI.SE for more info.","ref":"DragoniteEDI.GS.html","title":"DragoniteEDI.GS","type":"module"},{"doc":"Struct defined for IEA node at EDI message. IEA node indicates the end of a transaction.fields - an enum of string fields.","ref":"DragoniteEDI.IEA.html","title":"DragoniteEDI.IEA","type":"module"},{"doc":"Struct defined for ISA node at EDI message. ISA node indicates the start of a transaction containing multiple functional groups.fields - an enum of string fields.gs - an enum of DragoniteEDI.GS nodes. See DragoniteEDI.GS for more info.ge - a node of DragoniteEDI.GE. See DragoniteEDI.GE for more info.","ref":"DragoniteEDI.ISA.html","title":"DragoniteEDI.ISA","type":"module"},{"doc":"Struct defined for Edi message. EDI message contains mainly two nodes composed by DragoniteEDI.ISA and DragoniteEDI.IEA. See DragoniteEDI.ISA, DragoniteEDI.IEA for more info.An extra data is included sts, because a single message will be splitted in multiple messages, containing multiple STs, then to validate ST length, we need store the original ST length value, instead of take from message.STs is automatic filled and should not be used to handle other data.isa - a node of DragoniteEDI.ISA.iea - a node of DragoniteEDI.IEAsts - number of STS","ref":"DragoniteEDI.Message.html","title":"DragoniteEDI.Message","type":"module"},{"doc":"Struct defined for SE node at EDI message. SE node indicates the end of a segment.fields - an enum of string fields.","ref":"DragoniteEDI.SE.html","title":"DragoniteEDI.SE","type":"module"},{"doc":"Struct defined for ST node at EDI message. ST node indicates the start of a segment.fields - an enum of string fields.values - an enum of enums where each enum contains strings.","ref":"DragoniteEDI.ST.html","title":"DragoniteEDI.ST","type":"module"}]